<template>
  <div
    data-component-group="lists"
    data-component="activity-logs"
  >
    <v-list
      two-line
      class="logs-list"
    >
      <template v-for="(log, index) in rows">
        <v-list-tile
          :key="index"
          avatar
          class="log-item"
        >
          <v-list-tile-avatar>
            <v-icon>
              account_circle
            </v-icon>
          </v-list-tile-avatar>

          <div>
            <v-list-tile-title :title="`${log.actor} ${log.msg}`">
              <span class="actor">
                {{ log.actor }}
              </span>
              {{ ' ' }}
              <span class="action">
                {{ log.msg }}
              </span>
            </v-list-tile-title>
            <span
              v-if="log.additionalText"
              class="subtitle"
              v-html="log.additionalText"
            ></span>
            <span class="timestamp">
              {{ log.timestamp }}
            </span>
          </div>
        </v-list-tile>
      </template>
    </v-list>

    <div class="component-actions">
      <v-pagination
        v-if="pagination.perPage < pagination.totalItems"
        v-model="pagination.page"
        :length="pagination.lastPage"
        :total-visible="20"
        @input="onChangePage"
      />
    </div>
  </div>
</template>

<script>
  export default {
    props: {
      rows: {
        type: Array,
        required: true
      },
      pagination: {
        type: Object,
        required: true
      }
    },
    methods: {
      onChangePage(page) {
        this.$emit('change-page', page);
      }
    }
  };
</script>

<style lang="stylus">
  @import '../../assets/stylus/theme.styl';

  [data-component-group="lists"] {
    &[data-component="activity-logs"] {
      .logs-list {
        overflow-x: hidden;
        border-radius: 4px;
      }

      .log-item {
        padding: 10px 0;
        border-bottom: 1px solid $colors.grey.lighten-2;

        &:last-child {
          border: none;
        }
      }

      .action {
        color: $colors.grey.base;
      }

      .subtitle {
        display: block;
        color: $colors.grey.darken-2;
        margin: 10px 0 0 0;

        p {
          font-size: 14px;
        }
      }

      .timestamp {
        display: block;
        color: $colors.grey.base;
        font-size: 12px;
      }

      .v-list__tile {
        height: auto;
        min-height: 72px;
      }

      .v-list__tile__avatar {
        min-width: 50px;
      }

      > .component-actions {
        padding: 10px;
        text-align: center;

        .trigger.load-more-rows {
          border-radius: 4px;

          &:before {
            background-color: $colors.grey.darken-1;
          }
        }
      }
    }
  }
</style>
